# application\_just\_nodejs

A simpler version of: <https://github.com/conradev/application_nodejs>

## Description

This cookbook is designed to be able to describe and deploy node.js applications.

Note that this cookbook provides the node.js-specific bindings for the `application` cookbook; you will find general documentation in that cookbook.

## Requirements

Chef 11.0.0 or higher required (for Chef environment use).

The following Opscode cookbooks are dependencies:

* application

## Resources/Providers

The LWRP provided by this cookbook is not meant to be used by itself; make sure you are familiar with the `application` cookbook before proceeding.

### `just_nodejs`

The `just_nodejs` sub-resource LWRP deals with deploying node.js apps from an SCM repository. It uses the `deploy_revision` LWRP to perform the bulk of its tasks, and many concepts and parameters map directly to it. Check the documentation for `deploy_revision` for more information.

It will install specified modules using `npm install`.

#### Attribute Parameters

- npm\_command: The command to execute when calling bundler commands. Useful for specifing alternate commands. Defaults to `npm`.
- npm\_options: additional options which will be appended to the end of the `npm` command string.

## Usage

A sample recipe that uses the `nodejs` cookbook to provide node.js and `application_procfile` to start the app:

```ruby
node.default['nodejs']['version'] = '0.10.28'
node.default['nodejs']['npm'] = '1.4.9'

include_recipe 'nodejs'
include_recipe 'nodejs::install_from_source'
include_recipe 'application_procfile'

application 'example' do
  path '/srv/example'

  owner 'ubuntu'
  group 'ubuntu'

  packages ['git']
  repository 'git@github.com:user/example.git'

  deploy_key File.read(File.expand_path('../../deploy_key', __FILE__))

  just_nodejs do
  end

  procfile do
    app 1
  end
end
```
